# coding: utf-8

# flake8: noqa

"""
    Core Operations

    The Sparkfly Platform provides a full lifecycle for promotions and rewards from creation to distribution to settlement. The platform integrates in real-time at the point-of-sale and provides item level discounting and tracking. The capabilities of the Sparkfly Platform are available through the use of the Sparkfly Platform API.  The Sparkfly documentation site is under development. If the documentation you're after isn't available here, please contact support@sparkfly.com and we will get you what you need.

    The version of the OpenAPI document: 1.0
    Contact: support@sparkfly.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.1.10"

# Define package exports
__all__ = [
    "AudiencesApi",
    "AuthenticationApi",
    "BIStoreListsApi",
    "CampaignsApi",
    "CtmApi",
    "EligibleItemSetsApi",
    "EmailOptInApi",
    "ImpressionsApi",
    "ItemsApi",
    "MemberPrivacyApi",
    "MembersApi",
    "OfferListsApi",
    "OfferPOSOfferCodesApi",
    "OfferStatesApi",
    "OffersApi",
    "POSOfferCodesApi",
    "StoreListsApi",
    "StoresApi",
    "TemplatesApi",
    "ApiResponse",
    "ApiClient",
    "Configuration",
    "OpenApiException",
    "ApiTypeError",
    "ApiValueError",
    "ApiKeyError",
    "ApiAttributeError",
    "ApiException",
    "APIError",
    "Audience",
    "BiStoreList",
    "BiStoreListStoreListsInner",
    "CampaignIndexBody",
    "CampaignRequest",
    "CampaignRequestCampaign",
    "CampaignResponse",
    "CampaignResponseCampaign",
    "CampaignTagsResponse",
    "ClarkAndRiggsIndexBody",
    "ClarkAndRiggsProductCreateBody",
    "ClarkAndRiggsProductResponseBody",
    "ClarkAndRiggsProductResponseBodyClarkAndRiggsProduct",
    "CredentialBatchIndexBody",
    "CredentialBatchRequest",
    "CredentialBatchResponseBody",
    "CredentialBatchResponseBodyCredentialBatch",
    "CredentialBatchResponseBodyCredentialBatchCampaign",
    "CredentialBatchResponseBodyCredentialBatchOffer",
    "CtmQitemsRequest",
    "CtmRedemptionJobRequest",
    "CtmRedemptionJobRequestItemsInner",
    "CtmRedemptionJobRequestRedeemedOffersInner",
    "CtmRedemptionJobRequestRedeemedOffersInnerQualifyingItemsInner",
    "CtmRedemptionJobRequestSelectedOffersInner",
    "CtmTransactionJobRequest",
    "CtmTransactionShowResponse",
    "CtmTransactionShowResponseAvailibleOffersInner",
    "CtmTransactionShowResponseReusableOffers",
    "CtmTransactionShowResponseTransaction",
    "CtmTransactionShowResponseTransactionAddOffersInner",
    "CtmTransactionShowResponseTransactionAddOffersInnerQualifyingItemsInner",
    "CtmTransactionShowResponseTransactionAvailibleOffersInner",
    "CtmTransactionShowResponseTransactionCredentialsInner",
    "CtmTransactionShowResponseTransactionCredentialsInnerTxCredential",
    "CtmTransactionShowResponseTransactionDisplayMessagesInner",
    "CtmTransactionShowResponseTransactionErrorsInner",
    "CtmTransactionShowResponseTransactionRecieptMessagesInner",
    "EmailOptIn",
    "EmailOptInError",
    "Errors",
    "GetOfferLists200Response",
    "GetOfferLists200ResponseOfferListsInner",
    "HealthCheck",
    "Impression",
    "ImpressionAllOfImpression",
    "ImpressionErrorBody",
    "ImpressionIndexBody",
    "ImpressionRequest",
    "ImpressionRequestImpression",
    "ImpressionRequestImpressionAnnotations",
    "InlineObject",
    "InlineObject1",
    "InlineObject2",
    "InlineObject3",
    "InlineObject4",
    "InlineObject5",
    "Item",
    "ItemAllOfItem",
    "ItemIndexBody",
    "ItemRequest",
    "ItemRequestItem",
    "ItemSet",
    "ItemSetAllOfItemSet",
    "ItemSetIndexBody",
    "ItemSetRequest",
    "ItemSetRequestItemSet",
    "Member",
    "MemberAllOfMember",
    "MemberPrivacy",
    "MemberPrivacyCredentialsInner",
    "MemberPrivacyMember",
    "MemberProfile",
    "MemberRequest",
    "MemberRequestMember",
    "Offer",
    "OfferAllOfOffer",
    "OfferEligibleItemSet",
    "OfferEligibleItemSetAllOfEligibleItemSet",
    "OfferEligibleItemSetRequest",
    "OfferEligibleItemSetRequestEligibleItemSet",
    "OfferEligibleItemsSetIndex",
    "OfferIndexBody",
    "OfferList",
    "OfferPosOfferCode",
    "OfferPosOfferCodeAllOfOfferPosOfferCode",
    "OfferPosOfferCodeIndex",
    "OfferPosOfferCodeRequest",
    "OfferPosOfferCodeRequestOfferPosOfferCode",
    "OfferRequest",
    "OfferRequestOffer",
    "OfferRequestOfferEligibility",
    "OfferRequestOfferFormatting",
    "OfferRequestOfferFormattingEligibleStoreMap",
    "OfferState",
    "OfferStateAllOfOfferState",
    "OfferStateError",
    "OfferStateIndexBody",
    "OfferStateRequest",
    "OfferStateRequestOfferState",
    "OfferStateUpdate",
    "OfferStateUpdateOfferState",
    "PageResponseBody",
    "PosOfferCode",
    "PosOfferCodeAllOfPosOfferCode",
    "PosOfferCodeIndexBody",
    "PostAudiencesIdSubAudiencesRequest",
    "PostAudiencesRequest",
    "PostAuth401Response",
    "PostMembersIdOfferStatesIssue201Response",
    "PostMembersIdOfferStatesIssue201ResponseOfferState",
    "PostMembersIdOfferStatesIssueRequest",
    "PostMembersIdOfferStatesIssueRequestOfferState",
    "PostMembersProfileRequest",
    "PostOfferListsRequest",
    "PostOfferListsRequestOfferList",
    "Store",
    "StoreAllOfStore",
    "StoreAllOfStoreLocation",
    "StoreIndexBody",
    "StoreList",
    "StoreListAllOfStoreList",
    "StoreListIndexBody",
    "StoreListRequest",
    "StoreListRequestStoreList",
    "StoreRequest",
    "StoreRequestStore",
    "StoreRequestStoreContacts",
    "StoreRequestStoreContactsPrimary",
    "StoreRequestStoreLocation",
    "SubAudience",
    "Template",
    "Template2",
    "TemplateTemplatesInner",
]

# import apis into sdk package
from sparkfly.api.audiences_api import AudiencesApi as AudiencesApi
from sparkfly.api.authentication_api import AuthenticationApi as AuthenticationApi
from sparkfly.api.bi_store_lists_api import BIStoreListsApi as BIStoreListsApi
from sparkfly.api.campaigns_api import CampaignsApi as CampaignsApi
from sparkfly.api.ctm_api import CtmApi as CtmApi
from sparkfly.api.eligible_item_sets_api import EligibleItemSetsApi as EligibleItemSetsApi
from sparkfly.api.email_opt_in_api import EmailOptInApi as EmailOptInApi
from sparkfly.api.impressions_api import ImpressionsApi as ImpressionsApi
from sparkfly.api.items_api import ItemsApi as ItemsApi
from sparkfly.api.member_privacy_api import MemberPrivacyApi as MemberPrivacyApi
from sparkfly.api.members_api import MembersApi as MembersApi
from sparkfly.api.offer_lists_api import OfferListsApi as OfferListsApi
from sparkfly.api.offer_pos_offer_codes_api import OfferPOSOfferCodesApi as OfferPOSOfferCodesApi
from sparkfly.api.offer_states_api import OfferStatesApi as OfferStatesApi
from sparkfly.api.offers_api import OffersApi as OffersApi
from sparkfly.api.pos_offer_codes_api import POSOfferCodesApi as POSOfferCodesApi
from sparkfly.api.store_lists_api import StoreListsApi as StoreListsApi
from sparkfly.api.stores_api import StoresApi as StoresApi
from sparkfly.api.templates_api import TemplatesApi as TemplatesApi

# import ApiClient
from sparkfly.api_response import ApiResponse as ApiResponse
from sparkfly.api_client import ApiClient as ApiClient
from sparkfly.configuration import Configuration as Configuration
from sparkfly.exceptions import OpenApiException as OpenApiException
from sparkfly.exceptions import ApiTypeError as ApiTypeError
from sparkfly.exceptions import ApiValueError as ApiValueError
from sparkfly.exceptions import ApiKeyError as ApiKeyError
from sparkfly.exceptions import ApiAttributeError as ApiAttributeError
from sparkfly.exceptions import ApiException as ApiException

# import models into sdk package
from sparkfly.models.api_error import APIError as APIError
from sparkfly.models.audience import Audience as Audience
from sparkfly.models.bi_store_list import BiStoreList as BiStoreList
from sparkfly.models.bi_store_list_store_lists_inner import BiStoreListStoreListsInner as BiStoreListStoreListsInner
from sparkfly.models.campaign_index_body import CampaignIndexBody as CampaignIndexBody
from sparkfly.models.campaign_request import CampaignRequest as CampaignRequest
from sparkfly.models.campaign_request_campaign import CampaignRequestCampaign as CampaignRequestCampaign
from sparkfly.models.campaign_response import CampaignResponse as CampaignResponse
from sparkfly.models.campaign_response_campaign import CampaignResponseCampaign as CampaignResponseCampaign
from sparkfly.models.campaign_tags_response import CampaignTagsResponse as CampaignTagsResponse
from sparkfly.models.clark_and_riggs_index_body import ClarkAndRiggsIndexBody as ClarkAndRiggsIndexBody
from sparkfly.models.clark_and_riggs_product_create_body import ClarkAndRiggsProductCreateBody as ClarkAndRiggsProductCreateBody
from sparkfly.models.clark_and_riggs_product_response_body import ClarkAndRiggsProductResponseBody as ClarkAndRiggsProductResponseBody
from sparkfly.models.clark_and_riggs_product_response_body_clark_and_riggs_product import ClarkAndRiggsProductResponseBodyClarkAndRiggsProduct as ClarkAndRiggsProductResponseBodyClarkAndRiggsProduct
from sparkfly.models.credential_batch_index_body import CredentialBatchIndexBody as CredentialBatchIndexBody
from sparkfly.models.credential_batch_request import CredentialBatchRequest as CredentialBatchRequest
from sparkfly.models.credential_batch_response_body import CredentialBatchResponseBody as CredentialBatchResponseBody
from sparkfly.models.credential_batch_response_body_credential_batch import CredentialBatchResponseBodyCredentialBatch as CredentialBatchResponseBodyCredentialBatch
from sparkfly.models.credential_batch_response_body_credential_batch_campaign import CredentialBatchResponseBodyCredentialBatchCampaign as CredentialBatchResponseBodyCredentialBatchCampaign
from sparkfly.models.credential_batch_response_body_credential_batch_offer import CredentialBatchResponseBodyCredentialBatchOffer as CredentialBatchResponseBodyCredentialBatchOffer
from sparkfly.models.ctm_qitems_request import CtmQitemsRequest as CtmQitemsRequest
from sparkfly.models.ctm_redemption_job_request import CtmRedemptionJobRequest as CtmRedemptionJobRequest
from sparkfly.models.ctm_redemption_job_request_items_inner import CtmRedemptionJobRequestItemsInner as CtmRedemptionJobRequestItemsInner
from sparkfly.models.ctm_redemption_job_request_redeemed_offers_inner import CtmRedemptionJobRequestRedeemedOffersInner as CtmRedemptionJobRequestRedeemedOffersInner
from sparkfly.models.ctm_redemption_job_request_redeemed_offers_inner_qualifying_items_inner import CtmRedemptionJobRequestRedeemedOffersInnerQualifyingItemsInner as CtmRedemptionJobRequestRedeemedOffersInnerQualifyingItemsInner
from sparkfly.models.ctm_redemption_job_request_selected_offers_inner import CtmRedemptionJobRequestSelectedOffersInner as CtmRedemptionJobRequestSelectedOffersInner
from sparkfly.models.ctm_transaction_job_request import CtmTransactionJobRequest as CtmTransactionJobRequest
from sparkfly.models.ctm_transaction_show_response import CtmTransactionShowResponse as CtmTransactionShowResponse
from sparkfly.models.ctm_transaction_show_response_availible_offers_inner import CtmTransactionShowResponseAvailibleOffersInner as CtmTransactionShowResponseAvailibleOffersInner
from sparkfly.models.ctm_transaction_show_response_reusable_offers import CtmTransactionShowResponseReusableOffers as CtmTransactionShowResponseReusableOffers
from sparkfly.models.ctm_transaction_show_response_transaction import CtmTransactionShowResponseTransaction as CtmTransactionShowResponseTransaction
from sparkfly.models.ctm_transaction_show_response_transaction_add_offers_inner import CtmTransactionShowResponseTransactionAddOffersInner as CtmTransactionShowResponseTransactionAddOffersInner
from sparkfly.models.ctm_transaction_show_response_transaction_add_offers_inner_qualifying_items_inner import CtmTransactionShowResponseTransactionAddOffersInnerQualifyingItemsInner as CtmTransactionShowResponseTransactionAddOffersInnerQualifyingItemsInner
from sparkfly.models.ctm_transaction_show_response_transaction_availible_offers_inner import CtmTransactionShowResponseTransactionAvailibleOffersInner as CtmTransactionShowResponseTransactionAvailibleOffersInner
from sparkfly.models.ctm_transaction_show_response_transaction_credentials_inner import CtmTransactionShowResponseTransactionCredentialsInner as CtmTransactionShowResponseTransactionCredentialsInner
from sparkfly.models.ctm_transaction_show_response_transaction_credentials_inner_tx_credential import CtmTransactionShowResponseTransactionCredentialsInnerTxCredential as CtmTransactionShowResponseTransactionCredentialsInnerTxCredential
from sparkfly.models.ctm_transaction_show_response_transaction_display_messages_inner import CtmTransactionShowResponseTransactionDisplayMessagesInner as CtmTransactionShowResponseTransactionDisplayMessagesInner
from sparkfly.models.ctm_transaction_show_response_transaction_errors_inner import CtmTransactionShowResponseTransactionErrorsInner as CtmTransactionShowResponseTransactionErrorsInner
from sparkfly.models.ctm_transaction_show_response_transaction_reciept_messages_inner import CtmTransactionShowResponseTransactionRecieptMessagesInner as CtmTransactionShowResponseTransactionRecieptMessagesInner
from sparkfly.models.email_opt_in import EmailOptIn as EmailOptIn
from sparkfly.models.email_opt_in_error import EmailOptInError as EmailOptInError
from sparkfly.models.errors import Errors as Errors
from sparkfly.models.get_offer_lists200_response import GetOfferLists200Response as GetOfferLists200Response
from sparkfly.models.get_offer_lists200_response_offer_lists_inner import GetOfferLists200ResponseOfferListsInner as GetOfferLists200ResponseOfferListsInner
from sparkfly.models.health_check import HealthCheck as HealthCheck
from sparkfly.models.impression import Impression as Impression
from sparkfly.models.impression_all_of_impression import ImpressionAllOfImpression as ImpressionAllOfImpression
from sparkfly.models.impression_error_body import ImpressionErrorBody as ImpressionErrorBody
from sparkfly.models.impression_index_body import ImpressionIndexBody as ImpressionIndexBody
from sparkfly.models.impression_request import ImpressionRequest as ImpressionRequest
from sparkfly.models.impression_request_impression import ImpressionRequestImpression as ImpressionRequestImpression
from sparkfly.models.impression_request_impression_annotations import ImpressionRequestImpressionAnnotations as ImpressionRequestImpressionAnnotations
from sparkfly.models.inline_object import InlineObject as InlineObject
from sparkfly.models.inline_object1 import InlineObject1 as InlineObject1
from sparkfly.models.inline_object2 import InlineObject2 as InlineObject2
from sparkfly.models.inline_object3 import InlineObject3 as InlineObject3
from sparkfly.models.inline_object4 import InlineObject4 as InlineObject4
from sparkfly.models.inline_object5 import InlineObject5 as InlineObject5
from sparkfly.models.item import Item as Item
from sparkfly.models.item_all_of_item import ItemAllOfItem as ItemAllOfItem
from sparkfly.models.item_index_body import ItemIndexBody as ItemIndexBody
from sparkfly.models.item_request import ItemRequest as ItemRequest
from sparkfly.models.item_request_item import ItemRequestItem as ItemRequestItem
from sparkfly.models.item_set import ItemSet as ItemSet
from sparkfly.models.item_set_all_of_item_set import ItemSetAllOfItemSet as ItemSetAllOfItemSet
from sparkfly.models.item_set_index_body import ItemSetIndexBody as ItemSetIndexBody
from sparkfly.models.item_set_request import ItemSetRequest as ItemSetRequest
from sparkfly.models.item_set_request_item_set import ItemSetRequestItemSet as ItemSetRequestItemSet
from sparkfly.models.member import Member as Member
from sparkfly.models.member_all_of_member import MemberAllOfMember as MemberAllOfMember
from sparkfly.models.member_privacy import MemberPrivacy as MemberPrivacy
from sparkfly.models.member_privacy_credentials_inner import MemberPrivacyCredentialsInner as MemberPrivacyCredentialsInner
from sparkfly.models.member_privacy_member import MemberPrivacyMember as MemberPrivacyMember
from sparkfly.models.member_profile import MemberProfile as MemberProfile
from sparkfly.models.member_request import MemberRequest as MemberRequest
from sparkfly.models.member_request_member import MemberRequestMember as MemberRequestMember
from sparkfly.models.offer import Offer as Offer
from sparkfly.models.offer_all_of_offer import OfferAllOfOffer as OfferAllOfOffer
from sparkfly.models.offer_eligible_item_set import OfferEligibleItemSet as OfferEligibleItemSet
from sparkfly.models.offer_eligible_item_set_all_of_eligible_item_set import OfferEligibleItemSetAllOfEligibleItemSet as OfferEligibleItemSetAllOfEligibleItemSet
from sparkfly.models.offer_eligible_item_set_request import OfferEligibleItemSetRequest as OfferEligibleItemSetRequest
from sparkfly.models.offer_eligible_item_set_request_eligible_item_set import OfferEligibleItemSetRequestEligibleItemSet as OfferEligibleItemSetRequestEligibleItemSet
from sparkfly.models.offer_eligible_items_set_index import OfferEligibleItemsSetIndex as OfferEligibleItemsSetIndex
from sparkfly.models.offer_index_body import OfferIndexBody as OfferIndexBody
from sparkfly.models.offer_list import OfferList as OfferList
from sparkfly.models.offer_pos_offer_code import OfferPosOfferCode as OfferPosOfferCode
from sparkfly.models.offer_pos_offer_code_all_of_offer_pos_offer_code import OfferPosOfferCodeAllOfOfferPosOfferCode as OfferPosOfferCodeAllOfOfferPosOfferCode
from sparkfly.models.offer_pos_offer_code_index import OfferPosOfferCodeIndex as OfferPosOfferCodeIndex
from sparkfly.models.offer_pos_offer_code_request import OfferPosOfferCodeRequest as OfferPosOfferCodeRequest
from sparkfly.models.offer_pos_offer_code_request_offer_pos_offer_code import OfferPosOfferCodeRequestOfferPosOfferCode as OfferPosOfferCodeRequestOfferPosOfferCode
from sparkfly.models.offer_request import OfferRequest as OfferRequest
from sparkfly.models.offer_request_offer import OfferRequestOffer as OfferRequestOffer
from sparkfly.models.offer_request_offer_eligibility import OfferRequestOfferEligibility as OfferRequestOfferEligibility
from sparkfly.models.offer_request_offer_formatting import OfferRequestOfferFormatting as OfferRequestOfferFormatting
from sparkfly.models.offer_request_offer_formatting_eligible_store_map import OfferRequestOfferFormattingEligibleStoreMap as OfferRequestOfferFormattingEligibleStoreMap
from sparkfly.models.offer_state import OfferState as OfferState
from sparkfly.models.offer_state_all_of_offer_state import OfferStateAllOfOfferState as OfferStateAllOfOfferState
from sparkfly.models.offer_state_error import OfferStateError as OfferStateError
from sparkfly.models.offer_state_index_body import OfferStateIndexBody as OfferStateIndexBody
from sparkfly.models.offer_state_request import OfferStateRequest as OfferStateRequest
from sparkfly.models.offer_state_request_offer_state import OfferStateRequestOfferState as OfferStateRequestOfferState
from sparkfly.models.offer_state_update import OfferStateUpdate as OfferStateUpdate
from sparkfly.models.offer_state_update_offer_state import OfferStateUpdateOfferState as OfferStateUpdateOfferState
from sparkfly.models.page_response_body import PageResponseBody as PageResponseBody
from sparkfly.models.pos_offer_code import PosOfferCode as PosOfferCode
from sparkfly.models.pos_offer_code_all_of_pos_offer_code import PosOfferCodeAllOfPosOfferCode as PosOfferCodeAllOfPosOfferCode
from sparkfly.models.pos_offer_code_index_body import PosOfferCodeIndexBody as PosOfferCodeIndexBody
from sparkfly.models.post_audiences_id_sub_audiences_request import PostAudiencesIdSubAudiencesRequest as PostAudiencesIdSubAudiencesRequest
from sparkfly.models.post_audiences_request import PostAudiencesRequest as PostAudiencesRequest
from sparkfly.models.post_auth401_response import PostAuth401Response as PostAuth401Response
from sparkfly.models.post_members_id_offer_states_issue201_response import PostMembersIdOfferStatesIssue201Response as PostMembersIdOfferStatesIssue201Response
from sparkfly.models.post_members_id_offer_states_issue201_response_offer_state import PostMembersIdOfferStatesIssue201ResponseOfferState as PostMembersIdOfferStatesIssue201ResponseOfferState
from sparkfly.models.post_members_id_offer_states_issue_request import PostMembersIdOfferStatesIssueRequest as PostMembersIdOfferStatesIssueRequest
from sparkfly.models.post_members_id_offer_states_issue_request_offer_state import PostMembersIdOfferStatesIssueRequestOfferState as PostMembersIdOfferStatesIssueRequestOfferState
from sparkfly.models.post_members_profile_request import PostMembersProfileRequest as PostMembersProfileRequest
from sparkfly.models.post_offer_lists_request import PostOfferListsRequest as PostOfferListsRequest
from sparkfly.models.post_offer_lists_request_offer_list import PostOfferListsRequestOfferList as PostOfferListsRequestOfferList
from sparkfly.models.store import Store as Store
from sparkfly.models.store_all_of_store import StoreAllOfStore as StoreAllOfStore
from sparkfly.models.store_all_of_store_location import StoreAllOfStoreLocation as StoreAllOfStoreLocation
from sparkfly.models.store_index_body import StoreIndexBody as StoreIndexBody
from sparkfly.models.store_list import StoreList as StoreList
from sparkfly.models.store_list_all_of_store_list import StoreListAllOfStoreList as StoreListAllOfStoreList
from sparkfly.models.store_list_index_body import StoreListIndexBody as StoreListIndexBody
from sparkfly.models.store_list_request import StoreListRequest as StoreListRequest
from sparkfly.models.store_list_request_store_list import StoreListRequestStoreList as StoreListRequestStoreList
from sparkfly.models.store_request import StoreRequest as StoreRequest
from sparkfly.models.store_request_store import StoreRequestStore as StoreRequestStore
from sparkfly.models.store_request_store_contacts import StoreRequestStoreContacts as StoreRequestStoreContacts
from sparkfly.models.store_request_store_contacts_primary import StoreRequestStoreContactsPrimary as StoreRequestStoreContactsPrimary
from sparkfly.models.store_request_store_location import StoreRequestStoreLocation as StoreRequestStoreLocation
from sparkfly.models.sub_audience import SubAudience as SubAudience
from sparkfly.models.template import Template as Template
from sparkfly.models.template2 import Template2 as Template2
from sparkfly.models.template_templates_inner import TemplateTemplatesInner as TemplateTemplatesInner
