# coding: utf-8

"""
    Core Operations

    The Sparkfly Platform provides a full lifecycle for promotions and rewards from creation to distribution to settlement. The platform integrates in real-time at the point-of-sale and provides item level discounting and tracking. The capabilities of the Sparkfly Platform are available through the use of the Sparkfly Platform API.  The Sparkfly documentation site is under development. If the documentation you're after isn't available here, please contact support@sparkfly.com and we will get you what you need.

    The version of the OpenAPI document: 1.0
    Contact: support@sparkfly.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CtmRedemptionJobRequestItemsInner(BaseModel):
    """
    CtmRedemptionJobRequestItemsInner
    """ # noqa: E501
    ln: Optional[StrictStr] = None
    lln: Optional[StrictStr] = None
    entry_id: Optional[StrictStr] = None
    linked_entry_id: Optional[StrictStr] = None
    cat: Optional[StrictStr] = None
    desc: Optional[StrictStr] = None
    ic: Optional[StrictStr] = None
    qw: Optional[StrictInt] = None
    original_qw: Optional[StrictInt] = None
    price: Optional[StrictInt] = None
    original_price: Optional[StrictInt] = None
    disc_val: Optional[StrictInt] = None
    seat: Optional[StrictStr] = None
    level: Optional[StrictStr] = None
    voided: Optional[StrictBool] = None
    type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["ln", "lln", "entry_id", "linked_entry_id", "cat", "desc", "ic", "qw", "original_qw", "price", "original_price", "disc_val", "seat", "level", "voided", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CtmRedemptionJobRequestItemsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CtmRedemptionJobRequestItemsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ln": obj.get("ln"),
            "lln": obj.get("lln"),
            "entry_id": obj.get("entry_id"),
            "linked_entry_id": obj.get("linked_entry_id"),
            "cat": obj.get("cat"),
            "desc": obj.get("desc"),
            "ic": obj.get("ic"),
            "qw": obj.get("qw"),
            "original_qw": obj.get("original_qw"),
            "price": obj.get("price"),
            "original_price": obj.get("original_price"),
            "disc_val": obj.get("disc_val"),
            "seat": obj.get("seat"),
            "level": obj.get("level"),
            "voided": obj.get("voided"),
            "type": obj.get("type")
        })
        return _obj


